#include <bits/stdc++.h>
using namespace std;

const vector<int> DR = {-1, 1, 0, 0};
const vector<int> DC = {0, 0, -1, 1};

int D, N;
vector< vector<int> > sachovnica;

int farba_utocnika(int r, int c, int d) {
    if (r < 0 || r >= D || c < 0 || c >= D) return 0;
    if (sachovnica[r][c] != 0) return sachovnica[r][c];
    return farba_utocnika( r+DR[d], c+DC[d], d );
}

int main() {
    cin >> D >> N;
    sachovnica.resize(D, vector<int>(D,0) );
    while (N--) {
        int r, c;
        string t;
        cin >> r >> c >> t;
        sachovnica[r][c] = (t == "B" ? 1 : 2);
    }
    vector< vector<int> > odpoved(5, vector<int>(5,0));
    for (int r=0; r<D; ++r) for (int c=0; c<D; ++c) if (sachovnica[r][c] == 0) {
        vector<int> pocet(3,0);
        for (int d=0; d<4; ++d) ++pocet[ farba_utocnika(r,c,d) ];
        ++odpoved[ pocet[1] ][ pocet[2] ];
    }
    for (int b=0; b<5; ++b) for (int c=0; c<5; ++c) if (odpoved[b][c] > 0) cout << b << " " << c << " " << odpoved[b][c] << endl;
}
