#include <bits/stdc++.h>
using namespace std;

const vector<int> DR = {-1, 1, 0, 0};
const vector<int> DC = {0, 0, -1, 1};

struct veza {
    int r, c, t;
    veza(int r, int c, int t) : r(r), c(c), t(t) {}
};

bool operator<(const veza &A, const veza &B) { if (A.r != B.r) return A.r < B.r; else return A.c < B.c; }

int main() {
    // nacitanie vstupu
    int D, N;
    cin >> D >> N;
    vector<veza> V;
    for (int n=0; n<N; ++n) {
        int r, c;
        string t;
        cin >> r >> c >> t;
        V.emplace_back(r,c,t == "B" ? 1 : 2);
    }
    set< pair<int,int> > policka_vezi;
    for (auto v : V) policka_vezi.insert( {v.r,v.c} );

    map<pair<int,int>, pair<int,int>> nenulove_policka;

    for (auto v : V) {
        for (int d=0; d<4; ++d) {
            int cr = v.r, cc = v.c;
            while (true) {
                if (v.t == 1) ++nenulove_policka[ {cr,cc} ].first; else ++nenulove_policka[ {cr,cc} ].second;
                cr += DR[d];
                cc += DC[d];
                if (cr < 0 || cr >= D || cc < 0 || cc >= D) break;
                if (policka_vezi.count( {cr,cc} )) break;
            }
        }
    }

    vector< vector<long long> > odpoved(5, vector<long long>(5,0));
    odpoved[0][0] = 1LL*D*D - nenulove_policka.size();
    for (auto rec : nenulove_policka) if (!policka_vezi.count(rec.first)) ++odpoved[rec.second.first][rec.second.second];
    for (int b=0; b<5; ++b) for (int c=0; c<5; ++c) if (odpoved[b][c] > 0) cout << b << " " << c << " " << odpoved[b][c] << endl;
}
